package lecture3

import scala.collection.*
import scala.collection.parallel.CollectionConverters.MapIsParallelizable

@main def parallelGraphContractionCorrect =
  val graph =
    concurrent.TrieMap[Int, Int]() ++= (0 until 100000).map(i => (i, i + 1))
  graph(graph.size - 1) = 0
  var previous = graph.snapshot()
  for (k, v) <- graph.par do graph(k) = previous(v)
  val violation = graph.find {
    case (i, v) => v != (i + 2) % graph.size
  }
  println(s"violation: $violation")
